<script setup lang="ts">
import { defineProps, ref, watch } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import { useStore } from 'vuex'
import type { Pipeline } from '@/api/gitlabApi/pipelinesApi'
import PipelinesApi from '@/api/gitlabApi/pipelinesApi'
import type { Project } from '@/api/gitlabHelperApi/projectsApi'
import { statusColor } from '@/components/gitlab/helpers'

const props = defineProps<{
  project: Project | null
}>()

const store = useStore()
const router = useRouter()
const route = useRoute()
const user = ref({ username: '', rol: '' })

const itemsPerPage = ref(10)
const pipelines = ref<Array<Pipeline>>([])
const totalPipelines = ref(0)
const search = ref('')
const loading = ref(false)

const headers = ref([
  { key: 'id', title: 'Id' },
  { key: 'status', title: 'Status' },
  { key: 'ref', title: 'Branch' },
  { key: 'source', title: 'Source', sortable: false },
  { key: 'created_at', title: 'Created', sortable: false },
  { key: 'updated_at', title: 'Updated' },
  { key: 'jobs', title: 'Jobs' },
  { key: 'web_url', title: 'URL' },
])

const getPipelines = async (itemsPerPage: number, page: number, sortKey: string, orderBy: string) => {
  if (!props.project)
    return
  loading.value = true

  const pipelinesApi = new PipelinesApi()
  try {
    const response = await pipelinesApi.getPipelines(props.project.id, itemsPerPage, page, sortKey, orderBy)

    pipelines.value = response.data
    totalPipelines.value = Number(response.headers['x-total'])
    console.debug('PipelinesTableComponent.getPipelines pipelines.value: ', pipelines.value)
    console.debug('PipelinesTableComponent.getPipelines totalPipelines.value: ', totalPipelines.value)
  }
  catch (error) {
    console.error('PipelinesTableComponent.getPipelines error: ', error)
  }
  loading.value = false
}

const fetchData = ({ page, itemsPerPage, sortBy }) => {
  if (!props.project)
    return
  console.debug('DEBUG: fetching data: page and perPage', { page, itemsPerPage })
  console.debug('DEBUG: fetching data: sortBy', sortBy[0])
  let sortByKey = 'id'
  if (sortBy !== undefined && sortBy.length > 0)
    sortByKey = sortBy[0].key

  let orderBy = 'desc'
  if (sortBy !== undefined && sortBy.length > 0)
    orderBy = sortBy[0].order

  getPipelines(itemsPerPage, page, sortByKey, orderBy)
}

// Handle row click to navigate to the execution details
const navigateToExecution = (pipeline: Pipeline) => {
  if (!props.project)
    return
  const projectId = props.project.id
  const pipelineId = pipeline.id
  const groupId = props.project.namespace.id

  console.log('Pipeline is : ', pipeline)
  console.log('Project is : ', props.project)
  router.push(`/vendors/${groupId}/project/${projectId}/pipelines/${pipelineId}/execution`)
}

watch(() => props.project, (newProject: Project | null) => {
  if (newProject) {
    fetchData({ page: 1, itemsPerPage: itemsPerPage.value, sortBy: [{ key: 'id', order: 'desc' }] })
  }
  else {
    pipelines.value = [] // Clear the pipelines if no project is selected
    totalPipelines.value = 0
  }
}, { immediate: true })
</script>

<template>
  <VCard class="flex-card">
    <VCardItem>
      <div class="d-flex justify-space-between flex-wrap">
        <VCardTitle v-if="props.project">
          <VIcon
            color="primary"
            icon="tabler-files"
            size="22"
          />
          <span class="ms-3">{{ props.project.name }}</span>
        </VCardTitle>
        <VBtn
          v-if="props.project && ['developer', 'root'].includes(user.rol.toLowerCase())"
          :href="props.project.web_url"
          variant="text"
          size="small"
        >
          <VIcon
            color="primary"
            icon="tabler-external-link"
            size="22"
          />
        </VBtn>
      </div>
    </VCardItem>

    <VCardText>
      <VDataTableServer
        v-model:items-per-page="itemsPerPage"
        :headers="headers"
        :items="pipelines"
        :items-length="totalPipelines"
        :loading="loading"
        :search="search"
        item-value="name"
        @update:options="fetchData"
      >
        <template #item.status="{ item }">
          <VChip
            label
            :color="statusColor(item.status)"
          >
            {{ item.status }}
          </VChip>
        </template>
        <template #item.web_url="{ item }">
          <VBtn
            :href="item.web_url"
            variant="text"
            size="small"
          >
            <VIcon
              color="primary"
              icon="tabler-external-link"
              size="22"
            />
          </VBtn>
        </template>
        <!-- Add click event to the entire row and apply styles here -->
        <template #item="{ item }">
          <tr
            class="clickable-row"
            @click="navigateToExecution(item)"
          >
            <td>{{ item.id }}</td>
            <td>
              <VChip
                label
                :color="statusColor(item.status)"
              >
                {{ item.status }}
              </VChip>
            </td>
            <td>{{ item.ref }}</td>
            <td>{{ item.source }}</td>
            <td>{{ item.created_at }}</td>
            <td>{{ item.updated_at }}</td>
            <td>{{ item.jobs }}</td>
            <td>
              <VBtn
                :href="item.web_url"
                variant="text"
                size="small"
              >
                <VIcon
                  color="primary"
                  icon="tabler-external-link"
                  size="22"
                />
              </VBtn>
            </td>
          </tr>
        </template>
      </VDataTableServer>
    </VCardText>
  </VCard>
</template>

<style scoped>
.clickable-row {
  cursor: pointer;
  transition: background-color 0.3s;
}
.clickable-row:hover {
  background-color: #f5f5f5; /* Light gray background color on hover */
}
</style>
